#!/bin/sh
# The script detect is the epoll system (replacing select) is
# available on this machine. It simply tries to compile
# a sample program. If it works, it prints "-DHAS_EPOLL"
# If it does not work, it prints nothing. This is used in the Makefile
FILE=/tmp/hasepool-$$.c
cat <<-EOF >$FILE
	#include <sys/epoll.h>

	void f(){
		int fd = epoll_create(10);
	}
EOF

OUT=has_epoll-tmp.bak
if g++ -c $FILE -o /dev/null 2>/dev/null >/dev/null
then
	echo "#define HAS_EPOLL" >$OUT
else
	echo "#undef HAS_EPOLL" >$OUT
fi
rm -f $FILE

